﻿/*************************************\
 *            Navigierung            *
 *                                   *
 * Kapitel: XML-Verarbeitung         *
 * Zuordnung: C#-Buch V2.0 6.4       *
 *                                   *
 *  Copyright 2015 by Benjamin Jung  *
\*************************************/
using System;
using System.Xml.XPath;

namespace CSV20.XML_Navigierung
{
    class Program
    {
        static void Main(string[] args)
        {
            XPathDocument oDocument;
            XPathNavigator oNavigator;

            try
            {
                oDocument = new XPathDocument("test.xml");
                oNavigator = oDocument.CreateNavigator();

                // zum (ersten) Wurzel-Element navigieren
                oNavigator.MoveToFirstChild();
                
                // versuchen in die untegeordnete Elementen-Ebene zu wechseln
                if (oNavigator.MoveToFirstChild())
                {
                    // mit einer Schleife durch alle direkt untergeordneten Elemente (2. Ebene) gehen
                    do
                    {
                        if (oNavigator.NodeType == XPathNodeType.Comment)
                            Console.WriteLine("Kommentar: " + oNavigator.Value);
                        else if (oNavigator.NodeType == XPathNodeType.Element)
                        {
                            Console.WriteLine("Element: " + oNavigator.Name);
                            if (oNavigator.HasChildren)
                                Console.WriteLine(" -> weitere Unterelemente vorhanden");
                            // versuchen in die Attribut-Ebene zu wechseln
                            if (oNavigator.MoveToFirstAttribute())
                            {
                                Console.WriteLine(" -> Attribute vorhanden:");
                                // mit einer Schleife durch alle Attribute des Elementes gehen
                                do
                                {
                                    Console.WriteLine("   + {0} = {1}", oNavigator.Name, oNavigator.Value);
                                } while (oNavigator.MoveToNextAttribute());
                                // wieder zurück in die Elementen-Ebene wechseln
                                oNavigator.MoveToParent();
                            }
                        }
                    }
                    while (oNavigator.MoveToNext());
                }

                // oDocument und oNavigator müssen nicht geschlossen werden
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }

            Console.ReadKey();
        }
    }
}